<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Modifier Types</TITLE>
<link href="suif1_68.html" rel=Next>
<link href="suif1_66.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_66.html">previous</A>, <A HREF="suif1_68.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC67" HREF="suif1_toc.html#TOC67">Modifier Types</A></H2>
<P>
<A NAME="IDX501"></A>
<A NAME="IDX502"></A>

</P>
<P>
<A NAME="IDX503"></A>
<A NAME="IDX504"></A>
<A NAME="IDX505"></A>
Modifier types are used to add various attributes to other types.  Each
attribute is represented by a different type operator:

</P>
<DL COMPACT>

<DT><CODE>TYPE_CONST</CODE>
<DD>
This modifier signals that the type is for constant values.

<DT><CODE>TYPE_VOLATILE</CODE>
<DD>
This is used for the types of variables whose contents may change at any
time.

<DT><CODE>TYPE_CALL_BY_REF</CODE>
<DD>
This is used in the Fortran mode (see section <A HREF="suif1_89.html#SEC89">Features for Compiling Fortran</A>) to identify
call-by-reference parameters.

<DT><CODE>TYPE_NULL</CODE>
<DD>
This modifier has no effect on the type but simply provides a place to
attach annotations.  This is needed for named types because copying them
would create completely new types.
</DL>

<P>
All of these modifier types use the <CODE>modifier_type</CODE> derived class.
The <CODE>base</CODE> method returns a pointer to the type that is modified,
and the <CODE>set_base</CODE> method changes that field.  More than one
modifier can be applied to the same type.  The order of the modifiers
does not matter, but no modifier should be used more than once with the
same type (for example, a constant constant integer is illegal, but a
constant pointer to a constant integer is OK).

</P>
<P>
<A NAME="IDX506"></A>
<A NAME="IDX507"></A>
<A NAME="IDX508"></A>
<A NAME="IDX509"></A>
<A NAME="IDX510"></A>
The base <CODE>type_node</CODE> class includes several methods to deal with
modifiers.  The <CODE>is_const</CODE>, <CODE>is_volatile</CODE>, and
<CODE>is_call_by_ref</CODE> methods check for the corresponding modifiers on a
type.  The <CODE>unqual</CODE> method skips over any modifier types and
returns the unqualified type.  This is used frequently when checking for
particular kinds of types.  Finally, the <CODE>find_modifier</CODE> method
checks if a type is modified by a particular modifier type operator.  If
so, it returns a pointer to that modifier type; otherwise it returns
<CODE>NULL</CODE>.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_66.html">previous</A>, <A HREF="suif1_68.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
